// The RadioButtons class is basically a set of toggle buttons, and checks to make sure only one is selected.

class RadioButtons {

  int numButtons;
  boolean[] radioChoose;
  boolean[] previousRadioChoose;
  ToggleButton[] radioButtons;
  BangButton tutLabel;
  color labelFore;
  color labelBack;

  
  // Origin of the set of toggle buttons
  int xR, yR;
  int rows, cols;
  int wR, hR;
  int wSpace, hSpace;


  RadioButtons(int xR_, int yR_, int wR_, int hR_, int wSpace_, int hSpace_, int col_, int row_, int numButtons_ ){
  xR = xR_;
  yR = yR_;

  rows = row_;
  cols = col_;
  numButtons = numButtons_;

  wR = wR_;
  hR = hR_;
  wSpace = wSpace_;
  hSpace = hSpace_;

  previousRadioChoose = new boolean[numButtons];
  radioButtons = new ToggleButton[numButtons];

  for (int i = 0; i < numButtons; i++){
  	radioButtons[i] = new ToggleButton(xR + (i % cols ) * (wR + hSpace)  , yR + int(i / cols)* (hR + hSpace), wR, hR, str(i+1), str(i+1), " ");  
    radioButtons[i].isItOn = false;
    previousRadioChoose[i] = false;
  }

  tutLabel = new BangButton(xR, yR - 20, wR*3+wSpace*2, 20, "", 1);
  //tutLabel.setState(0,0, "Tutorial", color(0,50,50), color(0,50,100) );

} // End constructor


void update(){

  if (backgroundBang.state==0){
    labelFore = color(0,0,0);
    labelBack = color(0,0,100);
  } else {
    labelFore = color(0,0,100);
    labelBack = color (0,0,0);
  }

  tutLabel.setState(0,0, "Tutorial", labelBack, labelFore );

   tutLabel.update();

  for (int i = 0; i < numButtons; i++){

    radioButtons[i].update();

    if (previousRadioChoose[i] != radioButtons[i].isItOn && radioButtons[i].isItOn == true){
      for (int j = 0; j < numButtons; j++){
        radioButtons[j].isItOn = false;
      }
      radioButtons[i].isItOn = true;
    }
    
    previousRadioChoose[i] = radioButtons[i].isItOn;
  }
}


boolean isItActive (int i){
  if(radioButtons[i].isItOn == true){
    return true;
  } else {
    return false;
  }
}

void turnOn(int i){
  radioButtons[i].isItOn = true;
}

void turnOff(int i){
  radioButtons[i].isItOn = false;
}

boolean allOff() {
  int sum = 0;
  for (int i = 0; i < numButtons; i++){
    sum += int(radioButtons[i].isItOn);
  }
  if (sum == 0) {return true;}
  else          {return false;}
}

void turnAllOff(){
  for (int i = 0; i < radioButtons.length; i++){
    radioButtons[i].isItOn = false;
  }
}

} // end class
