
class Sine {
  float n;
  color c;

  float hueSine, satSine, valSine;





  int N = 800;  // Number of samples or "bins"
  float[] barHeight;
  float[] barBottom; 
  float[] barTop;
  float period;

  float amplitude;
  float dAmp;
  float dPhase;
  float dFreq;

  float currentAmp;
  float currentPhase;
  float currentFreq;


  float baseline;
  float phase;
  



  float[] velocity;
  boolean falling = false;
  

  
  Sine(float n_, float amplitude_, float phase_, float baseline_, float hue_){
   
    n = n_;   // frequency of the sine wave in sin(nx)
    amplitude = amplitude_/2; // amplitude of sine wave in pixels
    phase = phase_; // phase of the sine wave 
    hueSine = hue_; // hueVar of the rectangles
    baseline = baseline_;   // starting y-value of baseline
    
    
    period = 6.283185307;  // processing.js does not recognize TAU;
        
    velocity = new float[N];
    barTop = new float[N];
    barBottom = new float[N];
    barHeight = new float[N];
     
    falling = false;
    
    for (int i = 0; i < N; i++){
      barHeight[i] = amplitude; 
      barBottom[i] = baseline;
      barTop[i] = barBottom[i] - barHeight[i];
      velocity[i] = 0;
    }
  } // end Sine constructor
  


  void printVal(){
   for (int i= 0; i < N; i++){
     println(barHeight[i]);
   }
  }
  
  void update(){
    
    
    for (int i = 0; i < N; i++){
    
       currentPhase = phase + dPhase * frameCount;
       
       // Using sines...
       if (sinesOrCosines==true){
         currentAmp = amplitude  * (sin((float(frameCount) * dAmp)+3.141/2) + 1)/2 ;
         currentFreq = n * (sin(float(frameCount) * dFreq) +1 )/1;
         barHeight[i] = currentAmp * sin((currentFreq * i * (period/N)) - currentPhase ) + currentAmp;
       }

       // Using cosines...
        else if (sinesOrCosines == false){
         currentAmp = amplitude  * (cos(float(frameCount) * dAmp + 0) + 1)/2 ;
         currentFreq = n * (cos(float(frameCount) * dFreq) +1 )/2;
         barHeight[i] = currentAmp * cos((currentFreq * i * (period/N)) - currentPhase ) + currentAmp;
       }
      barTop[i]    = barBottom[i] - barHeight[i];
    }
    
    
    
  }
  
 void fall(int i){
  velocity[i] += acceleration;
  barBottom[i] += velocity[i];
 }
 

 void halt(int i, float value){
   barBottom[i] = value;
  if (stickyBang.state == 1) {velocity[i] = 0;} // Bug or feature? 
 }
      
  float checkTop(int i){
    return barTop[i];
  }
  
  float checkBot(int i){
    return barBottom[i];
  }
  
  // Initially the number of samples in a sine was referred to as "bins"
  int bins(){
    return N;
  }
  


//////////////////////////////////
////////////////////////////////// display functions

  void displayBoxes(){
    for (int i = 0; i < N; i++){
      noStroke();
      fill(hueSine, satSine, valSine, 100);
      rect(int(i*(widthSine/N)), ceil(barBottom[i]), int(widthSine/N), floor(-barHeight[i]));
    }
  }

  void displayBoxStroke(){
   
    float strokeVal;

    if (backgroundBang.state==0){
      strokeVal = 0;
    } else {
      strokeVal = 100;
    }

    for (int i = 0; i < N; i++){ 
      noFill();
      strokeWeight(1);
      stroke(0, 0, strokeVal, 25);
      rect(int(i*(widthSine/N)), ceil(barBottom[i]), int(widthSine/N), floor(-barHeight[i]));
    }
  }
  



  void displayLine(int weight){
    color lineColor;
    //float lineVal = 0;

    // quick and dirty way of making the Sum line black/white. This assumes that the Sum line is set to be thicker than 6.
    if (weight > 6){
      if (backgroundBang.state==0){
        lineColor = color(0,0,0);
      } else {
        lineColor = color(0,0,100);
      }
    } else {
        lineColor = color(hueSine, satSine, valSine);
    }



    for(int i = 0; i < N-1; i++){
      stroke(lineColor);
      strokeWeight(weight);
      line(i*(widthSine/N)+widthSine/(2*N), barTop[i], (i+1)*(widthSine/N)+widthSine/(2*N), barTop[i+1]);
    }
  }
  //////////////////////////////  end display functions
  ////////////////////////////// 
  
  void setAmplitude (float amp_) {
    amplitude = amp_/2;
  }

  void setPhase (float phase_) {
    phase = phase_;
  }

  void setFreq (float freq_) {
    n = freq_;
  }

  void setDeltaAmplitude(float dAmp_) {
    dAmp = dAmp_/100;
  }

  void setDeltaPhase( float dPhase_) {
    dPhase = dPhase_/100;
  }

  void setDeltaFreq(float dFreq_) {
    dFreq = dFreq_/1000;
  }

  
  void setBinNum (int bins) {
    N = bins;
  }
  
  void setHue (float hue_) {
    if (hue_ < 0) {hue_ += 360;}
    hueSine = hue_;
  }

  void setVal (float val_){
    if (val_ < 0){val_ += 100;}
    valSine = val_;
  }

  void setSat (float sat_) {
    if (sat_ < 0) {sat_ +=100;}
    satSine = sat_;
  }

  void raiseToBaseline() {
    for (int i = 0; i < N; i++){
      barBottom[i] = baseline;
    }
  }

 void setVelocity(float vel_) {
  for (int i=0; i < N; i++){
    velocity[i] = vel_;
  }
 }




} // end of Sine class

// Sinusoid: do you say "sine-uh-soyd," "sine-us-oyd," "sine-ya-soyd," "sine-you-soyd" or "sines and cosines"? 


