
//  Adding sinusoids: by Steve Kranz, 2013-2014. This code is free and open.

// This original code is released on the MONTH DAYth, YEAR under 

// IMprovements:
// 1. Pie-chart visualization
// 2. Sound adaptation
// 3. Array list/ fix Num Sine selection
// 4. 

PImage testImage;
boolean showHelpImage = false;
boolean showAllControls = true;
boolean record = false; // for recording animation
boolean sinesOrCosines = false; // true = sines, false = cosines

boolean showHelpTextGlobal = false;
int helpX = 240 + 23;
int helpY = 107;
int helpW = 800 - 46;
int helpH = 40;

PFont mainFont, tutFont, tutNumFont;
PFont mainFontBold;
PFont titleFont;
PFont helpFont, helpTitleFont;

int count = 0; // for preventing toggle button from toggling more than once per click. 
int countFPA = 0; // for cycling through precalculated functions.
int dropCount = 0;
int prevDropCount = 0;
int raiseCount = 0;
int prevRaiseCount = 0;
int preSetCount = 0;
int prevPreSetCount =0;
int psCallCount = 0;

int numPreFunc;
float[][][] preFunc; // hold values for freq, phase and amplitude for functions like square wave, triangle wave, and cetera.


int[] binValues = {8,16,25,50,100,160,200,400,800};
int[] numSineValues = {1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 12, 15, 20, 30, 40};

float acceleration;  // how fast the boxes fall





/////////// COLORS
color hueOscBackColor, hueOscTextColor, hueModBackColor, hueModTextColor;
color satOscBackColor, satOscTextColor, satModBackColor, satModTextColor;
color valOscBackColor, valOscTextColor, valModBackColor, valModTextColor;
color b0_color, b1_color, b2_color;
color t0_color, t1_color, t2_color;
color labelColor;
color sumColor;
color horzRuleColor, ggColor;
color dropRaiseColor;

color backgroundColor, foregroundColor;



// The tut buttons are clickable boxes that contain text-based instructions and explanations 
TutButton[] tutButtonArray;
int[] previousTutButtonStates;


Sine[] sines;

// Dynamic Sliders
SliderBar[] ampSliders;
SliderBar[] phaseSliders;
SliderBar[] freqSliders;

SliderBar[] deltaAmpSliders;
SliderBar[] deltaPhaseSliders;
SliderBar[] deltaFreqSliders;

// Static Sliders
SliderBar hueSlider, satSlider, brightSlider;
SliderBar hueIncSlider, satIncSlider, valIncSlider;
SliderBar hueTimeSlider, satTimeSlider, valTimeSlider;
SliderBar hueIncTimeSlider, satIncTimeSlider, valIncTimeSlider;

SliderBar globalPhase, globalAmp, globalFreq;

SliderBar binSlider;
SliderBar numSlider;

// Buttons
RectButton[] dropButtons;


BangButton boxesButton, strokeButton, lineButton, sumButton;

BangButton hueBang, satBang, valBang;
BangButton hueIncBang, satIncBang, valIncBang;
BangButton hueTimeBang, satTimeBang, valTimeBang;
BangButton hueIncTimeBang, satIncTimeBang, valIncTimeBang;


BangButton gravityBang;
BangButton stickyBang;
BangButton backgroundBang;

BangButton zenBang;
BangButton dropBang;
BangButton raiseBang;
BangButton helpBang;


// Buttons that act as LABELS!!!!
BangButton numButton, binButton, globalAmpButton, globalPhaseButton, globalFreqButton, globalGlobalButton, globalHorzRuleButton;
BangButton frameRateButton;
BangButton spaceButton, timeButton, spaceHRbutton, timeHRbutton;

// Sine controller modifiers
SliderControl ampSliderControl, phaseSliderControl, freqSliderControl;
SliderControl deltaAmpSliderControl, deltaPhaseSliderControl, deltaFreqSliderControl;

RadioButtons tutorialRadio;




float[] freqs;
float[] amps;
float[] baselines;
float[] phases;

// The base HSV values for the sliders, and the arrays for the individual sines. Value = Brightness.
float hueBase, satBase, valBase;
float hueInc, satInc, valInc;
float hueTimeBase, satTimeBase, valTimeBase;
float hueIncTimeBase, satIncTimeBase, valIncTimeBase;

//float hbCounter, sbCounter, vbCounter; // hueBase counter, etc.

float previousHue, previousSat, previousVal;
float prevHueInc, prevSatInc, prevValInc;
int previousAmpToggleCount;
int previousBackgroundState = 0;

float[] hues, sats, vals;



boolean[] isFalling;

int numSine = 20;
int maxnNumSine = max(numSineValues);

int previousNumSine;





float heightSine;//
float widthSine = 800;
float boxHeight; // The max height a sine can be

int sinesTranslateX = 240;
int sinesTranslateY = 175; 



// Hide/show booleans
boolean showFrameBox = true;
boolean showBinsBox = true;
boolean showNumBox = true;
boolean showGlobalSliders = true;
boolean showButtons = true;
boolean showButtons2 = true;
boolean showZen = true;
boolean showColorSliders = true;
boolean showTutButtons = true;
boolean showTut = true;
boolean showSines = true;

boolean showColor1 = true;
boolean showColor2 = true;
boolean showColor3 = true;
boolean showColor4 = true;

boolean showFreq = true;
boolean showPhase = true;
boolean showAmp = true;
boolean showDeltaFreq = true;
boolean showDeltaPhase = true;
boolean showDeltaAmp = true;
boolean showSpaceLabel = true;
boolean showTimeLabel = true;



float tempGlobalFreq;
float tempGlobalAmp;
float tempGlobalPhase;


// These arrays are to keep track of the current state of the sinusoids so that they are not reset when the number of sines is changed ()
// currently not implemented. 
float[] saveFreq, savePhase, saveAmp, saveDeltaFreq, saveDeltaPhase, saveDeltaAmp, saveDrop;


void setup(){

  testImage = loadImage("quick_ref.jpg");
  

 String[] fontList = PFont.list();

 

  //noLoop();
  smooth();
  colorMode(HSB, 360, 100, 100, 100);

  size (1280, 720, JAVA2D);

  frameRate(30);

  mainFont = createFont("sans-serif", 12); 
  tutFont = createFont("sans-serif", 15);
  tutNumFont = createFont("sans-serif", 10);
  mainFontBold = createFont("sans-serif", 6);
  titleFont = createFont("sans-serif", 37);
  helpFont = createFont("sans-serif", 12);
  helpTitleFont = createFont("sans-serif", 30);
  textFont(mainFont);

  // println(fontList);
  

  setupButtons(300,10);
  gravityBang.state = 1; // set gravity to "medium" by default
  setupButtons2(815, 20); 
  setProgramColors();

  setupColorSliders(865, 25);

  setupSines();

  setupFrameBox(20, 5);
  setupSpaceTime();
  setupFrameBoxColors();
  
  setupColorButtons(865, 25);

  setupTutorial(475, 5, 330, 95, 10);
  setupPreFunc();
  
  setupHelpTextValues();
   
  
  
}




void draw() {

 // println(showSines);
  textFont(mainFont);
  
  if (backgroundBang.state == 0) {
    background(0,0, 100);
    } else {
      background(0,0,0);
    } 

    drawingWarning(); // if all drawing options are turned off, signal to turn on "Fill"

 /// DEBUG
//text(frameCount, 30,130);

  for (int i = 0; i < numSine; i++) {   
      
      if (showFreq){   sines[i].setFreq(freqSliderControl.sliders[i].getValue() * tempGlobalFreq );  }
      if (showPhase){  sines[i].setPhase(phaseSliderControl.sliders[i].getValue() +  tempGlobalPhase * freqSliderControl.sliders[i].getValue() ); }
      if (showAmp){ sines[i].setAmplitude(map(ampSliderControl.sliders[i].getValue(), 0, 100, 0, boxHeight) * tempGlobalAmp); }  // map so amplitude values go from 0 - 100, but are drawn form 0 to max height a sine can be.    }


      if(showDeltaFreq)  {sines[i].setDeltaFreq(deltaFreqSliderControl.sliders[i].getValue());}
      if(showDeltaAmp)  {sines[i].setDeltaAmplitude(deltaAmpSliderControl.sliders[i].getValue());}
      if(showDeltaPhase) { sines[i].setDeltaPhase(deltaPhaseSliderControl.sliders[i].getValue());}


      
     
      

      sines[i].setBinNum(binValues[int(binSlider.getValue())]);

      if(isFalling[i] == true ){
         drop(i);
       }

    
    // where "if(showSines)" used to be
     if(showSines){
        pushMatrix();
        translate(sinesTranslateX, sinesTranslateY);
        sines[i].update();
    
    
        // Display the sine waves
        if (boxesButton.state != 0) {sines[i].displayBoxes();}
        if (strokeButton.state != 0) {sines[i].displayBoxStroke();}
        
        popMatrix();
     }

    
    

  }
  
    // Seperate loop that iterates through the sine waves so ensure correct layering
   for (int i = 0; i < numSine; i++) {
    

    pushMatrix();
    translate(sinesTranslateX, sinesTranslateY);
    if(showSines){
      if (lineButton.state == 1 || lineButton.state == 2 ) {sines[i].displayLine(3);}
    }
       popMatrix();
   

     // do not draw button for bottom-most sine
    if (i != 0){
    dropButtons[i].update();
    }
   }


if (frameCount < 910 && tutorialRadio.allOff() == true) {
  tutorialRadio.radioButtons[0].flashOn();
}

//background(0,0,100);

  //test1.display();

// draw background box for tool tips (AKA help);

drawHelpBackground();
/*
if(helpBang.state==1){
  fill(0,0,92);
  noStroke();
  rect(helpX, helpY, helpW, helpH);
}*/


// for Debugging ---------------
  fill(100);
 // text(frameCount, width-50, 50); 
 // text(frameRate, width-50, 70);
//----------------------------


//strokeWeight(1);
//stroke(color(0,50,90));
//line(0, 100, width, 100);

acceleration = .03 * gravityBang.returnValue();
  


/* Temproary rectangle for background measurements  
noStroke();
fill(330);
rect(sinesTranslateX, sinesTranslateY, widthSine, heightSine);
*/



 // General "static" sliders

 //globalAmp.update();

 // Toggle buttons
 
updateTutorial();
resetTutorial(); // to prevent a debugging nightmare...



 
 if (showButtons){
 updateButtons();
}

if (showButtons2){
  updateButtons2();
}

if (showZen){
  updateZen();
}


if (showFrameBox){
   updateFrameBox();
}

if (showBinsBox){
  updateBinsBox();
}

if (showNumBox){
  updateNumBox();
}


// Show/hide functions are built into these functions.
switchColorButtons();
 updateColorButtons();
 colorSlidersUpdate();






 numSine = numSineValues[int(numSlider.getValue())]; 
 

 // Have things changed around here?
 
 if(numSineChange()) { 
  setupSines();
  setupSpaceTime();
  setupFrameBoxColors();
  }



if (showSpaceLabel){
  updateSpace();
}

if (showTimeLabel){
  updateTime();
}
// if(ampAvgChange()) { ampAvgEval();}


 if( hueChange() || hueIncChange() ) { setupHues(hueBase); }
 if( satChange() || satIncChange() ) { setupSats(satBase); }
 if( valChange() || valIncChange() ) { setupVals(valBase); }

 if (backgroundBang.state != previousBackgroundState) {
  setProgramColors();
 }


// The sets of sliders that control the amplitude, phase and frequency of the sinusoids in both space and time.
if(showFreq)  {freqSliderControl.update(); }
if(showAmp)  {ampSliderControl.update();  }
if(showPhase) {phaseSliderControl.update();}

if(showDeltaFreq)  {deltaFreqSliderControl.update();}
if(showDeltaAmp)  {deltaAmpSliderControl.update();  }
if(showDeltaPhase) {deltaPhaseSliderControl.update();}







if (showGlobalSliders){
  updateGlobalBox();
}



// big ol' loop went here



  pushMatrix();
  translate(sinesTranslateX, sinesTranslateY);
   if(sumButton.state != 0) {sines[sines.length-1].displayLine(7);}
  popMatrix();

   // Record the state of certain sliders.
  previousHue = hueBase;
  previousSat = satBase;
  previousVal = valBase;

  prevHueInc = hueInc;
  prevSatInc = satInc;
  prevValInc = valInc;

  previousNumSine = numSine;
 
  previousBackgroundState = backgroundBang.state;


  //saveFrame("test1-#####.png");


   // Reset hide/show booleans to default values (i.e., true or showing).
   resetHideBooleans();
   turnOnSliderControlButtons();

   if (showHelpImage){
    image(testImage,0,0);
   }

   if(showAllControls == false){
    hideAllControls();
   }

dropCount = dropBang.toggleCount;
raiseCount = raiseBang.toggleCount;

 checkDropRaise();

 prevDropCount = dropCount;
 prevRaiseCount = raiseCount;

setupHelpTextValues();  // I shouldn't need to call this function here (should only need in setup(), but I need to for the "spaceButton" to work correctly...for some reason...
  
if(psCallCount==1){
  checkPreSets();
  psCallCount = 0;  
}


if (record == true){
saveFrameFunction();
}

} // End draw
  
 
