void setupTutorial(int xT, int yT, int wT, int hT, int numLessons) {
     
     //  1. Intro
     //  2. Drop/raise
     //  3. Colors2
     //  4. Bins/sines, drawing options
     //  5. Global sliders + buttons (minus sticky)
     //  6. Functions (square wave, triangle wave, etc)
     //  7. Time FPA
     //  8. Colors3
     //  9. Colors4 
    

    tutorialRadio = new RadioButtons(xT-85, yT+18, 25, 25, 1, 1, 3, 3, 9);

    previousTutButtonStates = new int[numLessons];
    for (int i = 0; i < numLessons; i++){
      previousTutButtonStates[i] = 999; //some number greater than the number of lessons
    }


    tutButtonArray = new TutButton[numLessons];  

    tutButtonArray[0] = new TutButton(xT, yT, wT, hT, 10);
    tutButtonArray[0].setState(0, "Hello! This tutorial will show you how to add sine waves!\n\nTo procede, left-click in this box, or hit the right arrow key.");
    tutButtonArray[0].setState(1, "This is a cosine.");
    tutButtonArray[0].setState(2, "This is also a cosine.");
    tutButtonArray[0].setState(3, "Adjust the amplitude.\n\nIt's the height of the sine.");
    tutButtonArray[0].setState(4, "Adjust the phase. \n\nIt shifts left or right.");
    tutButtonArray[0].setState(5, "Adjust the frequency.\n\nIt's how many peaks there are.");
    tutButtonArray[0].setState(6, "Change the hue. \n\nHue is the color of the rainbow.");
    tutButtonArray[0].setState(7, "Change the saturation. \n\nSaturation is how vibrant the color is.\nZero is grey.");
    tutButtonArray[0].setState(8, "Change the brightness. \n\nBrightness is how light the color is. \nZero is black.");
    tutButtonArray[0].setState(9, "Next: Lesson 2\n\nTo exit: click current number \nTo exit: hit ESCAPE key");
    tutButtonArray[0].clickInstructions = false;

    tutButtonArray[1] = new TutButton(xT, yT, wT, hT, 12);
    tutButtonArray[1].setState(0, "Here's a second cosine wave.\n\nClick to continue.");
    tutButtonArray[1].setState(1, "Adjust the frequency, phase and amplitude independently.");
    tutButtonArray[1].setState(2, "We can add the waves together by having them fall down onto each other. Click on the top wave and it will fall down.");
    tutButtonArray[1].setState(3, "Click on the 'Raise' button to bring the wave up to its original position.\n\nShortcut: \\");
    tutButtonArray[1].setState(4, "Here are more sines. To drop them all simultaneously click on the 'Drop' button.\n\nShortcut: 'return' or 'enter'");
    tutButtonArray[1].setState(5, "Adjust the amplitudes of each. \n\nTry click-dragging down the sliders.");
    tutButtonArray[1].setState(6, "Decrease all amplitudes at the same time with the - button.");
    tutButtonArray[1].setState(7, "Increase all amplitudes at the same time with the + button.");
    tutButtonArray[1].setState(8, "Make the amplitudes randomly walk up or down with the )( button.");
    tutButtonArray[1].setState(9, "Equalize the amplitudes with the () button.\n\nClick multiple times.");
    tutButtonArray[1].setState(10, "These controls also work for the frequencies and phases.");
    tutButtonArray[1].setState(11, "Continue to lesson 3.\n\nLearn how to change the colors!");


    
    tutButtonArray[2] = new TutButton(xT, yT, wT, hT, 9);  
    
    tutButtonArray[2].setState(0, "We change the color of the bottom-most sine with these sliders.\n\nBy default, all the sines are the same color.");
    tutButtonArray[2].setState(1, "Adjust the amount the hue changes per every sine. \n\nRight-click to reset to 0.");
    tutButtonArray[2].setState(2, "Adjust the amonunt the saturation changes per every sine. \n\nIn the positive direction staturation quickly jumps from vibrant to grey.");
    tutButtonArray[2].setState(3, "Adjust the amount the brightness changes per every sine. \n\nIn the positive direction brightness quickly jumps from light to dark.");
    tutButtonArray[2].setState(4, "Adjusting both the change in hue and change in saturation makes some cool patterns.\n\nRight-click each slider to reset to 0.");
    tutButtonArray[2].setState(5, "Adjust saturation and brightness...");
    tutButtonArray[2].setState(6, "Adjust hue and brightness...");
    tutButtonArray[2].setState(7, "Adjust all three...");
    tutButtonArray[2].setState(8, "Click on lesson 4! \n\nLearn how to change how the sines are drawn!");


    tutButtonArray[3] = new TutButton(xT, yT, wT, hT, 8);
    tutButtonArray[3].setState(0, "Adjust the number of bins.\n\nThat's how many samples are in each sine wave." );
    tutButtonArray[3].setState(1, "Adjust the number of sines\n\nNOTE: This resets the frquency, phase and amplitude of each sine.");
    tutButtonArray[3].setState(2, "If both the number of bins and sines is too large, the program may slow down.\n\nCheck the frame rate indicator.\nFPS = frames per second");
    tutButtonArray[3].setState(3, "There are several ways to draw the sines.\n\nThe default is 'fill'.");
    tutButtonArray[3].setState(4, "'Stroke' draws a box around each sample in each sine.\n\nWARNING: This can slow down the program if the number of bins/sines is too high.");
    tutButtonArray[3].setState(5, "'Lines' connects the tops of the samples in each sine.\n\nWARNING: This can slow down the program if the number of bins/sines is too high.");
    tutButtonArray[3].setState(6, "'Sum' draws a line on the top-most sine.\n\nWhen all the sines are fallen it represents the sum of sines.");
    tutButtonArray[3].setState(7, "Continue on to lesson 5!\n\nTo exit: click current number.\nTo exit: hit '~' or '0'.");


    tutButtonArray[4] = new TutButton(xT, yT, wT, hT, 9);
    tutButtonArray[4].setState(0, "The Global sliders multiply the freqeuncy, phase and amplitude of all the sines by the same factor.");
    tutButtonArray[4].setState(1, "Increase the amplitude of all sines  using the global amplitude slider.\n\nRight-click or hit 'E' to reset to 1.");
    tutButtonArray[4].setState(2, "Shift all of the sines to the left or right using the global phase slider.\n\nRight-click or hit 'W' to reset to 0.");
    tutButtonArray[4].setState(3, "Increase or decrease the frequency of all sines by the same factor.\n\nRight-click or hit 'Q' to reset to 1.");
    tutButtonArray[4].setState(4, "High gravity drops the sines quickly... ");
    tutButtonArray[4].setState(5, "...while low gravity drops the sines slowly.");
    tutButtonArray[4].setState(6, "When 'Help' is on, hover over a button or slider for a brief explanation.");
    tutButtonArray[4].setState(7, "Turn the lights off for a darker view.");
    tutButtonArray[4].setState(8, "Hit '6' to continue to lesson 6!\n\nTo exit: click current lesson number.");


    tutButtonArray[5] = new TutButton(xT, yT, wT, hT, 7);
    tutButtonArray[5].setState(0, "We can adjust the amplitudes and phases of the sines to get some cool looking functions");
    tutButtonArray[5].setState(1, "This shape is called a sinc.\n\nIt peaks in the middle and oscillates smaller and smaller as it moves outward.");
    tutButtonArray[5].setState(2, "This is a square wave.\n\nThe global frequency is set to 4 so you see 4 periods.");
    tutButtonArray[5].setState(3, "This is a triangle wave.");
    tutButtonArray[5].setState(4, "This is a wave made of semi-circles.");
    tutButtonArray[5].setState(5, "This is a wave made of simi-circles curving upwards.");
    tutButtonArray[5].setState(6, "Click '7' to continue to lesson 7!\n\nTo exit: click on current lesson number.");

    tutButtonArray[6] = new TutButton(xT, yT, wT, hT, 13);
    tutButtonArray[6].setState(0, "We can adjust the sines in space.\n\nAnd also... in time.");
    tutButtonArray[6].setState(1, "Adjust ∆ Amp to make the sines' amplitude oscillate in magnitude.");
    tutButtonArray[6].setState(2, "If 10, the amplitude will oscillate quickly.\nIf 2, slowly.\n0, not at all. ");
    tutButtonArray[6].setState(3, "The sines' amplitudes oscillate between zero and it's spatial value.");
    tutButtonArray[6].setState(4, "Right-click each slider to reset it to 0.\n\nOr hit 'H' on the keyboard to reset all ∆ Amp sliders to zero.");
    tutButtonArray[6].setState(5, "∆ Phase changes the phase in time.\n\nThe sine will slide continuosly to the left or the right.");
    tutButtonArray[6].setState(6, "Right-click each ∆ Phase slider to reset it to 0.\n\nOr hit 'G' to reset all ∆ Phase sliders to zero");
    tutButtonArray[6].setState(7, "∆ Freq changes the frequency in time.\n\nThe frequency of the sine will oscillate between 0 and the spatial value of that sine's frequency");
    tutButtonArray[6].setState(8, "Right-click each ∆ Freq slider to reset it to 0.\n\nOr hit 'F' to reset all ∆ Freq sliders to zero.");
    tutButtonArray[6].setState(9, "Let's see how these parameters change in combination...");
    tutButtonArray[6].setState(10, "...kinda looks like the ocean.");
    tutButtonArray[6].setState(11, "Turn 'Sticky' off for an interesting visual.\n\nTurn 'Gravity' to low to enhance the effect.");
    tutButtonArray[6].setState(12, "Continue to lesson 8!");
    // this continues....


    tutButtonArray[7] = new TutButton(xT, yT, wT, hT, 9);
    tutButtonArray[7].setState(0, "We learned in Lesson 3 how to change the colors on the sines.\n\nBut we can also change the colors of the sines...in time!");
    tutButtonArray[7].setState(1, "The '∆H' slider adjusts how fast the hue changes over time.\n\nRight-click to reset to 0.");
    tutButtonArray[7].setState(2, "If the hue is changing spatially and in time...");
    tutButtonArray[7].setState(3, "The '∆S' slider adjusts how fast the saturation changes over time.\n\nRight-click to reset to 0.");
    tutButtonArray[7].setState(4, "The staturation changing in both space and time...");
    tutButtonArray[7].setState(5, "The '∆B' slider adjusts how fast the brightness changes over time.\n\nRight-click to reset to 0.");
    tutButtonArray[7].setState(6, "The brighness changing in both space and time...");
    tutButtonArray[7].setState(7, "We can change all three at once...");
    tutButtonArray[7].setState(8, "Continue to lesson 9!");
    // continues....


    tutButtonArray[8] = new TutButton(xT, yT, wT, hT, 8);
    tutButtonArray[8].setState(0, "Ok... so those colors are pretty crazy, right?\n\nWell... they get crazier.");
    tutButtonArray[8].setState(1, "The '∆dH' slider adjusts how fast the change-in-hue (dH) changes over time.\n\nRight-click to reset to 0.");
    tutButtonArray[8].setState(2, "The '∆dS' slider adjusts how fast the change-in-saturation (dS) changes over time.\n\nRight-click to reset to 0.");
    tutButtonArray[8].setState(3, "The '∆dB' slider adjusts how fast the change-in-brightness (dB) changes over time.\n\nRight-click to reset to 0.");
    tutButtonArray[8].setState(4, "All three at once is pretty crazy...");
    tutButtonArray[8].setState(5, "...and combined with other color sliders can be truly nuts.");
    tutButtonArray[8].setState(6, "Remember the sines can move too!");
    tutButtonArray[8].setState(7, "You've seen all the controls in \nSum Some Sines. Go play and have fun!\n\nHit '0' to exit.");





    



    





/*
    for (int i=6; i < numLessons; i++){
      tutButtonArray[i] = new TutButton(xT, yT, wT, hT, 1);
    }

    */

    tutButtonArray[9] = new TutButton(xT,yT,wT,hT, 3);
    tutButtonArray[9].setState(0, "sum\nsome\nsines");
    tutButtonArray[9].setState(1, "This program was inspired by Albert Michelson's Harmonic Analyzer: a 19th century machine that adds together sine waves using gears, springs and levers.");
    tutButtonArray[9].setState(2, "To learn more check out 'Engineer Guy' on YouTube or www.engineerguy.com.");
    tutButtonArray[9].setFont(titleFont, 30, -13, 0);
    tutButtonArray[9].creditText = true;
    tutButtonArray[9].progressNumbers = false;
    tutButtonArray[9].boldText = true;
  
} // end setupTutorial ????

boolean oneTimeEvent(int a, int b){
  boolean result;
  result = previousTutButtonStates[a] != b && tutButtonArray[a].state ==b;
  return result;
}

boolean tutState(int a, int b){
  boolean result;
  result = tutButtonArray[a].state == b;
  return result;
}
 
void resetTutorial(){
  for (int i = 0; i < tutorialRadio.numButtons; i++){
  if(tutorialRadio.radioButtons[i].isItOn == false){
    tutButtonArray[i].state = 0;
    previousTutButtonStates[i] = 998;
  }
}
}
// This is where actions, flashes and etc. take place. 
void updateTutorial(){





//          ////
//       ///////
//    //////////
//          ////
//          ////
//          ////
//          ////
//          ////
//          ////
//          ////
//          ////
//          ////     

   // Lesson 1 ---------------------------------
   if(tutorialRadio.isItActive(0)){
    tutButtonArray[0].update();

      hideFrameBox();
      hideGlobalSliders();
      hideButtons();
      hideButtons2();
      hideColor2();
      hideColor3();
      hideColor4();
      hideTime();
      hideBinsBox();
      hideNumBox();
      hideSpaceButtons();
      hideSpaceLabel();
      helpBang.state = 0;
      backgroundBang.state = 0;



    
    if(tutButtonArray[0].state==0){
      //hideTut();
    //  hideSines();
      showSines = false; // this does't do anything...
     // println(showSines);
      //hideTutButtons();
      hideColor1();
      hideSpace();
      setColor1(120, 50, 53);
      setColor3(0,0,0);
      setColor4(0,0,0);
      binSlider.setValue(8);
      numSlider.setValue(0);
      setSLSF(0,0,0,1);

       if (oneTimeEvent(0,0)){
        setGlobal(1,0,0);
        updateGlobalBox();
      }






    } else if (tutButtonArray[0].state==1) {
      //hideTutButtons();
      hideColor1();
      hideSpace();

      lineButton.state = 1;
      sumButton.state = 0;
      strokeButton.state = 0;
      boxesButton.state = 0;

      freqSliderControl.sliders[0].setValue(1);



    } else if (tutButtonArray[0].state==2){
      //hideTutButtons();
      hideColor1();
      hideSpace();

      sumButton.state = 0;
      lineButton.state = 0;
      strokeButton.state = 0;
      boxesButton.state = 1;
      // equivalent to: setSLSF(0,0,0,1);


    } else if (tutButtonArray[0].state==3){  //adjust amplitude
      //hideTutButtons();
      hideColor1();

      setSLSF(0,0,0,1); // sum, line, stroke, fill;
      hideFreq();
      hidePhase();
      ampSliderControl.sliders[0].flashOn();

    } else if (tutButtonArray[0].state==4){
      //hideTutButtons();
      hideColor1();
      setSLSF(0,0,0,1); // sum, line, stroke, fill;
      hideFreq();
      phaseSliderControl.sliders[0].flashOn();
    
    } else if (tutButtonArray[0].state==5){  //adjust frequency
      //hideTutButtons();
      hideColor1();
      setSLSF(0,0,0,1); // sum, line, stroke, fill;
      freqSliderControl.sliders[0].flashOn();

    } else if (tutButtonArray[0].state==6){
      //hideTutButtons();
      setSLSF(0,0,0,1);
      hueSlider.flashOn();
      satSlider.hide();
      brightSlider.hide();
      satBang.hide();
      valBang.hide(); // inconsistent variable name...

      
    } else if (tutButtonArray[0].state==7){
      //hideTutButtons();
      setSLSF(0,0,0,1);
      //satSlider.hide();
      satSlider.flashOn();
      brightSlider.hide();
      //satBang.hide();
      valBang.hide();
    
     } else if (tutButtonArray[0].state==8){
      //hideTutButtons();
      setSLSF(0,0,0,1);
      brightSlider.flashOn();
    
    } else if (tutButtonArray[0].state==9){
      //hideTutButtons();
      setSLSF(0,0,0,1);
      tutorialRadio.radioButtons[1].flashOn();
    }



         previousTutButtonStates[0] = tutButtonArray[0].state;
   }

 

 //               22222222222222222
 //               222222222222222222
 //                              2222
 //                              2222
 //                           22222
 //                         2222
//                        2222
 //                     2222
 //                   2222
 //                 2222
 //                 222222222222222222
 //                 222222222222222222


//2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2 2  2 2 2 2 2 2 2  (index 1)
/////////////////////////////////////////////////////////
 // Lesson 2 ------------------------------------
  if (tutorialRadio.isItActive(1) ) {
        tutButtonArray[1].update();

      hideFrameBox();
      


      hideGlobalSliders();
      hideButtons();
     // hideButtons2();
      //hideColor2();
      hideColor1();
      hideColor2();
      hideColor3();
      hideColor4();
      hideTime();
      hideBinsBox();
      hideNumBox();
      //hideSpaceButtons();
      hideSpaceLabel();
      helpBang.state = 0;

      



        if (tutButtonArray[1].state ==0){
          numSlider.setValue(1);
          binSlider.setValue(7);
         // setupSines();

          setColor1(225, 50, 80);
          setColor2(30,-20,10);
          setColor3(0,0,0);
          setColor4(0,0,0);
          
          //hueIncSlider.setValue(0);
          //satIncSlider.setValue(0);
          //valIncSlider.setValue(0);
          //dropButtons[1].deactivate();

          //setColor1(40,50,50);
          setSLSF(0,0,0,1);
          dropBang.hide();
          raiseBang.hide();
          hideColor1();
          //hideColor2();
          hideSpaceButtons();
          hideSpace();

          //dropButtons[1].deactivate();
          //dropButtons[1].hide();
          if (oneTimeEvent(1,0)){
                  setGlobal(1,0,0);
                  updateGlobalBox();
          }


          }



           else if(tutButtonArray[1].state==1) {

             //         setColor1(225, 50, 80);

                  phaseSliderControl.sliders[1].flashOn();
                  ampSliderControl.sliders[1].flashOn();
                  freqSliderControl.sliders[1].flashOn();
                  dropBang.hide();
                  raiseBang.hide();
          hideColor1();
          hideColor2();   
          dropButtons[1].hide();
          hideSpaceButtons();
          //hideSpace();
             
          }

          else if (tutButtonArray[1].state==2){
            numSlider.setValue(1);
            //println(numSlider.getValue());
           // println(dropButtons.length);
            dropButtons[1].flashOn();
            dropBang.hide();
            raiseBang.hide();
          hideColor1();
          hideColor2();
          hideSpaceButtons();


          if(oneTimeEvent(1,2)){
            sines[1].raiseToBaseline();
            sines[1].setVelocity(0);
            dropButtons[1].deactivate();
          }
        }


          else if(tutButtonArray[1].state==3){
            numSlider.setValue(1);
            dropBang.hide();
          hideColor1();
          hideColor2();
          hideSpaceButtons();


          raiseBang.flashOn();

            // use this conditional for events that should only occur once (i.e., not persistant changes in state)
            if(previousTutButtonStates[1] != 3 && tutButtonArray[1].state ==3){
                        dropButtons[1].activate();
  
            }
          }

          else if(tutButtonArray[1].state==4){
               numSlider.setValue(6);
               hideColor1();
               dropBang.flashOn();
          hideColor2();
          hideSpaceButtons();
          hideSpace();
          setColor2(30,0,0);


          }

          else if (tutButtonArray[1].state==5){
             hidePhase();
             hideFreq();
             hideSpaceButtons();
             for (int i = 0; i < numSine; i++){
              ampSliderControl.sliders[i].flashOn();
             }

          }

          else if (tutButtonArray[1].state==6){
            hidePhase();
            hideFreq();
            phaseSliderControl.buttonsOff();
            freqSliderControl.buttonsOff();
            ampSliderControl.plus.hide();
            ampSliderControl.explode.hide();
            ampSliderControl.collapse.hide();

            ampSliderControl.minus.flashOn(); 
          }

          else if(tutButtonArray[1].state==7){
            hidePhase();
            hideFreq();
            ampSliderControl.explode.hide();
            ampSliderControl.collapse.hide();

            ampSliderControl.plus.flashOn();
          }

          else if(tutButtonArray[1].state==8){
            hidePhase();
            hideFreq();
            ampSliderControl.collapse.hide();
            ampSliderControl.explode.flashOn();
          }

          else if(tutButtonArray[1].state==9){
            hidePhase();
            hideFreq();
            ampSliderControl.collapse.flashOn();

          } 

          else if (tutButtonArray[1].state==10){
            phaseSliderControl.plus.flashOn();
            phaseSliderControl.minus.flashOn();
            phaseSliderControl.collapse.flashOn();
            phaseSliderControl.explode.flashOn();

            freqSliderControl.plus.flashOn();
            freqSliderControl.minus.flashOn();
            freqSliderControl.collapse.flashOn();
            freqSliderControl.explode.flashOn();


          } 

          else if(tutButtonArray[1].state==11){
                  tutorialRadio.radioButtons[2].flashOn();
          }


     previousTutButtonStates[1] = tutButtonArray[1].state; // needed for oneTimeEvent() to work.
    }




//           33333333333333333
//           333333333333333333
//                          3333
//                          3333
//                          333
//              33333333333333
//              33333333333333
//                          333
//                          3333
//                          3333
//           333333333333333333
//           3333333333333333 


// 33 3 3 3 3 33 3 3 3 3 3 3 3 3 3 3 3 3 3 3 3 3 3 3 3 3 3 33  3 3 3 3 3 3 3 3 3 3
// ---------------------------------------------------------------------------

  if (tutorialRadio.isItActive(2) )      { 
           tutButtonArray[2].update();

          numSlider.setValue(11);
          binSlider.setValue(7); 

          setColor3(0,0,0);


      hideFrameBox();
      hideGlobalSliders();
      hideButtons();
     // hideButtons2();
      hideColor3();
      hideColor4();

      hideTime();
      hideSpace();
      hideBinsBox();
      hideNumBox();
      helpBang.state=0;




           
         if (tutButtonArray[2].state==0){
            hideColor2();
            hueSlider.flashOn();
            satSlider.flashOn();
            brightSlider.flashOn(); //  2 lazy 2 fix...
            setColor2(0,0,0);
            setGlobal(1,0,0);

            for (int i =0; i<numSine; i++){
              dropButtons[i].activate();
            }

            if(oneTimeEvent(2,0)){
              setColor1(220,40,75);
              setGlobal(1,0,0);
              updateGlobalBox();
      

            }
          }

          else if (tutButtonArray[2].state==1){
             hueIncSlider.flashOn();

             satSlider.setValue(40);
             brightSlider.setValue(75);

             satIncSlider.setValue(0);
             valIncSlider.setValue(0);

             satSlider.hide();
             satBang.hide();
             brightSlider.hide();
             valBang.hide();

            satIncBang.hide();
            satIncSlider.hide();
            valIncBang.hide();
            valIncSlider.hide();

            if(oneTimeEvent(2,1)){
             setColor1(220,40,75);
             hueIncSlider.setValue(15);
            }
          } 

          else if (tutButtonArray[2].state==2){
            hueSlider.setValue(220);
            brightSlider.setValue(75);

            hueIncSlider.setValue(0);
            hueIncSlider.hide();
            hueIncBang.hide();
            hueBang.hide();
            hueSlider.hide();
            
            valIncSlider.setValue(0);
            valIncSlider.hide();
            valIncBang.hide();
            brightSlider.hide();
            valBang.hide();
            
            satIncSlider.flashOn();

            if(oneTimeEvent(2,2)){
              setColor1(220,99,75);
              satIncSlider.setValue(-13);
              satSlider.setValue(99);

/*
              for(int i = 0; i<numSine; i++){
                sines[i].raiseToBaseline();
                sines[i].setVelocity(0);
                dropButtons[i].deactivate();
              }
*/
              
               // for(int i = 0; i < numSine; i++){
               //   if(i != 8){
                  //dropButtons[i].activate();
             //   }
             // }



            }
          } 

          else if (tutButtonArray[2].state==3){
            hueIncSlider.setValue(0);
            hueIncSlider.hide();
            hueIncBang.hide();
            hueSlider.hide();
            hueBang.hide();

            satSlider.setValue(40);
            hueSlider.setValue(5);

            satIncSlider.setValue(0);
            satIncSlider.hide();
            satIncBang.hide();
            satSlider.hide();
            satBang.hide();

            valIncSlider.flashOn();

            if(oneTimeEvent(2,3)){
              valIncSlider.setValue(-17);
              brightSlider.setValue(45);
            }


          } else if(tutButtonArray[2].state==4){
            valIncSlider.setValue(0);
            valIncSlider.hide();
            valIncBang.hide();

            hueIncSlider.flashOn();
            satIncSlider.flashOn();

            if(oneTimeEvent(2,4)){
              setColor1(0,50,85);
              setColor2(4, -22, 0);
            }

          }

          else if(tutButtonArray[2].state==5){
            hueIncSlider.setValue(0);
            hueIncSlider.hide();
            hueIncBang.hide();

            satIncSlider.flashOn();
            valIncSlider.flashOn();

            if(oneTimeEvent(2,5)){
              setColor1(0,93,0);
              setColor2(0,-6,6);
            }
          }

          else if(tutButtonArray[2].state==6){
            satIncSlider.setValue(0);
            satIncSlider.hide();
            satIncBang.hide();

            hueIncSlider.flashOn();
            valIncSlider.flashOn();
            
            if(oneTimeEvent(2,6)){
              setColor1(145,50,0);
              setColor2(-9, 0, 41);
            }
          } 

          else if(tutButtonArray[2].state==7){
            hueIncSlider.flashOn();
            valIncSlider.flashOn();
            satIncSlider.flashOn();

            if(oneTimeEvent(2,7)){
              setColor1(166, 59, 0);
              setColor2(18,-31, 6);
            }

          }

          else if (tutButtonArray[2].state==8){
            tutorialRadio.radioButtons[3].flashOn();
          } 

    



            previousTutButtonStates[2] = tutButtonArray[2].state;



         }

//                44444        44444
//                44444        44444
//               44444         44444
//               44444         44444
//              44444          44444
//              44444          44444
//              44444444444444444444
//              44444444444444444444
//                             44444
//                             44444
//                             44444
//                             44444
//                             44444
//                             44444

// 4444444444444444444444444444444444444444444444444444444444444444444444
// ---------------------------------------------------------------------------

  if (tutorialRadio.isItActive(3) )      { 
           tutButtonArray[3].update();

         

      
      hideGlobalSliders();
      hideButtons();
      hideColor1();
      hideColor2();
      hideColor3();
      hideColor4();
      hideTime();
      helpBang.state=0;
      setGlobal(1,0,0);





           
         if (tutButtonArray[3].state==0){

          hideSpace();
          setSLSF(0,0,0,1);
          hideNumBox();
          hideFrameBox();
          binSlider.flashOn();
          setColor1(50,27,99);
          setColor2(25,9,-10);
          setColor3(0,0,0);
          setColor4(0,0,0);

          if(oneTimeEvent(3,0)){
            binSlider.setValue(5);
            numSlider.setValue(5);
            setGlobal(1,0,0);
            updateGlobalBox();
    
          }


         }

         else if (tutButtonArray[3].state==1){
          hideBinsBox();
          hideFrameBox();
          numSlider.flashOn();



         }

         else if (tutState(3,2)){  // replaces tutButtonArray[3].state==2;
          sumButton.hide();
          lineButton.hide();
          strokeButton.hide();
          boxesButton.hide(); // should probably be renamed "fillButton" .... 
          frameRateButton.flashOn();
           hideSpace();

           if(oneTimeEvent(3,2)){
            binSlider.setValue(7);
            numSlider.setValue(13);
           }
         }

         else if (tutState(3,3)){ 
          sumButton.hide();
          lineButton.hide();
          strokeButton.hide();
          boxesButton.flashOn();
           hideSpace();
          

          if(oneTimeEvent(3,3)){
            binSlider.setValue(4);
            numSlider.setValue(5);
            setSLSF(0,0,0,1);
          }
         }

         else if (tutState(3,4)){  
          sumButton.hide();
          lineButton.hide();
          strokeButton.flashOn();
           hideSpace();

           if(oneTimeEvent(3,4)){
              setSLSF(0,0,1,1);
           }
         }

         else if (tutState(3,5)){ 
          sumButton.hide();
          lineButton.flashOn();
           hideSpace();
           
           if(oneTimeEvent(3,5)){
            setSLSF(0,1,0,0);
           }
         }

         else if (tutState(3,6)){  
          sumButton.flashOn();
           hideSpace();
           
           if(oneTimeEvent(3,6)){
            setSLSF(1,0,0,1);
            raiseAction();
            fallAction();

           }
         } 

         else if (tutState(3,7)){
          tutorialRadio.radioButtons[4].flashOn();
          hideSpace();
         }

     previousTutButtonStates[3] = tutButtonArray[3].state; // needed for oneTimeEvent() to work.

       }



 //         5555555555555555555555
 //         5555555555555555555555
 //         5555
 //         5555
 //         5555
 //         5555
 //         55555555555555555
 //         5555555555555555555
 //                        55555
 //                         5555
 //                         5555
 //                         5555
 //                         5555
 //                        55555
 //         5555555555555555555
 //         5555555555555555

  if (tutorialRadio.isItActive(4) )      { 
           tutButtonArray[4].update();

         

      
     // hideButtons();
      setupFrameBoxColors();
      hideFrameBox();
      hideBinsBox();
      hideNumBox();

      hideColor1();
      hideColor2();
      hideColor3();
      hideColor4();
     hideSpace();
      hideTime();
 



      if (tutState(4,0)){
       setBinNum(7,8);  // must call setBinNum() in step before amp/pha/freq adjust??
          setColor1(50,27,99);
          setColor2(25,9,-10);
          setColor3(0,0,0);
          setColor4(0,0,0);
          hideButtons();

          globalGlobalButton.flashOn();

          if(oneTimeEvent(4,0)){
            helpBang.state=0;
            setGlobal(1,0,1);
            setSLSF(0,0,0,1);
          }
      }


      else if (tutState(4,1)){
        hideButtons();
        globalAmp.flashOn();
    

        if (oneTimeEvent(4,1)){
          setGlobal(1,0,0);
          updateGlobalBox();


          dropSines();
         

          for (int i =0; i< numSine; i++){
            freqSliderControl.sliders[i].setValue(i+1);
            phaseSliderControl.sliders[i].setValue(0);
            ampSliderControl.sliders[i].setValue(100./(i+1));

           // freqSliderControl.sliders[i].update();
           // phaseSliderControl.sliders[i].update();
           // ampSliderControl.sliders[i].update();


          }
        } 
         

      }

      else if (tutState(4,2)){
        hideButtons();
        globalPhase.flashOn();
      }

      else if (tutState(4,3)){
        hideButtons();
        globalFreq.flashOn();
      }

      else if (tutState(4,4)){
        stickyBang.hide();
        helpBang.hide();
        backgroundBang.hide();



        gravityBang.flashOn();
        if(oneTimeEvent(4,4)){
          gravityBang.state=1;
          raiseSines();
          dropSines();
        }
      }

      else if (tutState(4,5)){
        stickyBang.hide();
        helpBang.hide();
        backgroundBang.hide();

        gravityBang.flashOn();
        if(oneTimeEvent(4,5)){
          gravityBang.state=0;
          raiseSines();
          dropSines();
        }
      }

      else if (tutState(4,6)){
        stickyBang.hide();
        backgroundBang.hide();

        helpBang.flashOn();
        if(oneTimeEvent(4,6)){
          helpBang.state=1;

        }
      }

        else if (tutState(4,7)){
          stickyBang.hide();
          backgroundBang.flashOn();
          if(oneTimeEvent(4,7)){
            backgroundBang.state=1;
          }
        }

        else if (tutState(4,8)){
          stickyBang.hide();
          tutorialRadio.radioButtons[5].flashOn();

        }

      
           previousTutButtonStates[4] = tutButtonArray[4].state;
} // end of 5



//              666666
//           6666666666666
//         6666        666
//         6666
//         6666
//         6666
//         6666666666666
//         6666666666666666
//         6666        6666
//         6666        6666
//         6666        6666
//         6666        6666
//           666666666666
//             6666666
// index 5
  if (tutorialRadio.isItActive(5) )      { 
           tutButtonArray[5].update();

           hideTime();
           setupFrameBoxColors();
           hideFrameBox();
          // updateColorButtons();
           hideColor1();
           hideColor2();
           hideColor3();
           hideColor4();
           hideButtons();
           hideSpaceLabel();
           helpBang.state = 0;
           setSLSF(0,0,0,1);


      if (tutState(5,0)){
                   dropSines();
                   setBinNum(7,12);
                   setColor1(10, 80, 18);
                   setColor2(8,-4,4);
                   setColor3(0,0,0);
                   setColor4(0,0,0);
                              setGlobal(1,0,1);

      } 

      else if (tutState(5,1)){
        if (oneTimeEvent(5,1)){
          setFPA(4); // sets FPA to create a sinc
          setGlobal(1,3.14,1);
        }

      }

      else if (tutState(5,2)){
        if(oneTimeEvent(5,2)){
          setFPA(0); // sets square wave
          setGlobal(2,0,10);
        }

      }

      else if (tutState(5,3)){
        if(oneTimeEvent(5,3)){
          setFPA(2); // set triangle wave
          setGlobal(4,0,6);
        }
      }

      else if (tutState(5,4)){
        if(oneTimeEvent(5,4)){
          setFPA(5); // set semicircles upward
          setGlobal(3,0,3);
        }
      }

      else if (tutState(5,5)){
        if(oneTimeEvent(5,5)){
          setFPA(1); // set semicircles downward
          setGlobal(3,0,3);

        }
      }

      else if (tutState(5,6)){
        tutorialRadio.radioButtons[6].flashOn();
      }


    previousTutButtonStates[5] = tutButtonArray[5].state;
  } // end of lesson 6



  //           7777777777777777777
  //           7777777777777777777
  //                          7777
  //                         7777
  //                        7777
  //                       7777
  //                      7777
  //                     7777
  //                    7777
  //                   7777
  //                  7777
  //                 7777
  //                7777

    if (tutorialRadio.isItActive(6) )      { 
           tutButtonArray[6].update();

           
           hideColor1();
           hideColor2();
           hideColor3();
           hideColor4();
           setupFrameBoxColors();
           //hideButtons();
           hideFrameBox();
           helpBang.state=0;
           


     hideGlobalSliders();

          // hideGlobalSliders();
           //updateGlobalBox();
         
          hideBinsBox();
          hideNumBox();

   

      if (tutState(6,0)){
        hideButtons();
        spaceButton.flashOn();
        timeButton.flashOn();
        ampSliderControl.buttonsOff();
        phaseSliderControl.buttonsOff();
        freqSliderControl.buttonsOff();
        hideDeltaFreq();
        hideDeltaPhase();
        hideDeltaAmp();
        hideButtons2();

        hideBinsBox();
        hideNumBox();

     //hideGlobalSliders();



          setBinNum(8,2);

          setColor1(5,99,18);
          setColor2(18, -24, 22);
          setColor3(0,0,0);
          setColor4(0,0,0);

          if(oneTimeEvent(6,0)){
            setGlobal(1,0,1);
            updateGlobalBox();
            stickyBang.state =0;
            
          }



      } 

      else if (tutState(6,1)){
        hideButtons();
        hideDeltaFreq();
        hideDeltaPhase();
        hideFreq();
        hidePhase();
        hideBinsBox();
        hideNumBox();
        deltaAmpSliderControl.labelButton.flashOn();
        deltaAmpSliderControl.buttonsOff();
        ampSliderControl.buttonsOff();

      }

      else if (tutState(6,2)){
        hideButtons();
        hideDeltaPhase();
        hideDeltaFreq();
        hideFreq();
        hidePhase();
        hideBinsBox();
        hideNumBox();
        deltaAmpSliderControl.sliders[1].flashOn();
        deltaAmpSliderControl.sliders[2].flashOn();
        deltaAmpSliderControl.buttonsOff();
        ampSliderControl.buttonsOff(); 

        if(oneTimeEvent(6,2)){
          deltaAmpSliderControl.sliders[1].setValue(2);
          deltaAmpSliderControl.sliders[2].setValue(10);
        }
      }


      else if (tutState(6,3)){
        hideButtons();
        hideDeltaFreq();
        hideDeltaPhase();
        hideFreq();
        hidePhase();
        hideBinsBox();
        hideNumBox();
        ampSliderControl.sliders[1].flashOn();
        ampSliderControl.sliders[2].flashOn();
        deltaAmpSliderControl.buttonsOff();
        ampSliderControl.buttonsOff();

        if(oneTimeEvent(6,3)){
          ampSliderControl.sliders[1].setValue(75);
          ampSliderControl.sliders[2].setValue(30);

        }
      }

      else if (tutState(6,4)){
        hideButtons();
        hideDeltaFreq();
        hideDeltaPhase();
        hideFreq();
        hidePhase();
        hideBinsBox();
        hideNumBox();
        deltaAmpSliderControl.sliders[1].flashOn();
        deltaAmpSliderControl.sliders[2].flashOn();
        deltaAmpSliderControl.sliders[0].flashOn();
        deltaAmpSliderControl.buttonsOff();
        ampSliderControl.buttonsOff();

        if(oneTimeEvent(6,4)){
          deltaAmpSliderControl.sliders[0].setValue(5);
          deltaAmpSliderControl.sliders[1].setValue(2);
          deltaAmpSliderControl.sliders[2].setValue(10);
          raiseSines();
          dropSines();
              for(int i=0; i<numSine; i++){
            phaseSliderControl.sliders[i].setValue(0);
            deltaPhaseSliderControl.sliders[i].setValue(0);
          }

        }

      }

      else if (tutState(6,5)){
        hideButtons();
        hideDeltaFreq();
        hideDeltaAmp();
        hideFreq();
        hideAmp();
        hideBinsBox();
        hideNumBox();

        deltaPhaseSliderControl.sliders[1].flashOn();
        deltaPhaseSliderControl.sliders[2].flashOn();
        deltaPhaseSliderControl.buttonsOff();
        phaseSliderControl.buttonsOff();

        if(oneTimeEvent(6,5)){
          raiseSines();
          deltaPhaseSliderControl.sliders[0].setValue(0);
          deltaPhaseSliderControl.sliders[1].setValue(-2);
          deltaPhaseSliderControl.sliders[2].setValue(6);
          for(int i=0; i<numSine; i++){
            ampSliderControl.sliders[i].setValue(100);
            deltaAmpSliderControl.sliders[i].setValue(0);
          }
        }
      }

      else if (tutState(6,6)){
        hideButtons();
        hideDeltaFreq();
        hideDeltaAmp();
        hideFreq();
        hideAmp();
        hideBinsBox();
        hideNumBox();
        deltaPhaseSliderControl.sliders[0].flashOn();
        deltaPhaseSliderControl.sliders[1].flashOn();
        deltaPhaseSliderControl.sliders[2].flashOn();
        deltaPhaseSliderControl.buttonsOff();
        phaseSliderControl.buttonsOff();
        
        if(oneTimeEvent(6,6)){
          deltaPhaseSliderControl.sliders[0].setValue(10);
          deltaPhaseSliderControl.sliders[1].setValue(-2);
          deltaPhaseSliderControl.sliders[2].setValue(6); 
          raiseSines();
          dropSines();

                 for(int i=0; i<numSine; i++){
            freqSliderControl.sliders[i].setValue(i+1);
            deltaFreqSliderControl.sliders[i].setValue(0);
          }
        }
      }

      else if (tutState(6,7)){
        hideButtons();
        hideDeltaAmp();
        hideDeltaPhase();
        hidePhase();
        hideAmp();
        hideBinsBox();
        hideNumBox();
        freqSliderControl.buttonsOff();
        deltaFreqSliderControl.buttonsOff();
        deltaFreqSliderControl.sliders[1].flashOn();
        deltaFreqSliderControl.sliders[2].flashOn(); 
        for(int i=0; i<numSine; i++){
          phaseSliderControl.sliders[i].setValue(0);
          deltaPhaseSliderControl.sliders[i].setValue(0);
        }
        if(oneTimeEvent(6,7)){
          raiseSines();
          deltaFreqSliderControl.sliders[0].setValue(0);
          deltaFreqSliderControl.sliders[1].setValue(2);
          deltaFreqSliderControl.sliders[2].setValue(10);

        }



       }

      else if (tutState(6,8)){
        hideButtons();
        hideDeltaAmp();
        hideDeltaPhase();
        hideAmp();
        hidePhase();
        hideBinsBox();
        hideNumBox();
        freqSliderControl.buttonsOff();
        deltaFreqSliderControl.buttonsOff();

        deltaFreqSliderControl.sliders[0].flashOn();
        deltaFreqSliderControl.sliders[1].flashOn();
        deltaFreqSliderControl.sliders[2].flashOn();

         if(oneTimeEvent(6,8)){
          deltaFreqSliderControl.sliders[0].setValue(5);
          deltaFreqSliderControl.sliders[1].setValue(2);
          deltaFreqSliderControl.sliders[2].setValue(10);
          raiseSines();
          dropSines();
        }

      }

      else if (tutState(6,9)){
        hideButtons();
         setBinNum(7,12);
         hideSpace();
         hideTime();
        if(oneTimeEvent(6,9)){
          setColor1(131,99,18);
          setColor2(6, -14, 13);
          setColor3(0,0,0);
          setColor4(0,0,0);
          raiseSines();


        }
      }

      else if (tutState(6,10)){
        hideButtons();

        //hideDeltaAmp();

        if (oneTimeEvent(6,10)){

          


          setColor1(221,99,18);
          setColor2(-3, -14, 13);
          setColor3(0,0,0);
          setColor4(0,0,0);

          for (int i=0; i<numSine; i++){
            freqSliderControl.sliders[i].setValue(i+1);
            phaseSliderControl.sliders[i].setValue(0);
            ampSliderControl.sliders[i].setValue(10+100/(i+1));

            dfv(i, 2 + 0.5*random(-1,1));
            dpv(i, 5 + 0.125*random(-1,1));
            dav(i, 1 + 0.25 *random(-1,1));



          }
          setGlobal(1,0,4);
          updateGlobalBox();


            raiseSines();
            dropSines();
          updateFPAsliders();



        }
      }

      else if (tutState(6,11)){
        helpBang.hide();
        backgroundBang.hide();
        stickyBang.flashOn();
        if(oneTimeEvent(6,11)){
          stickyBang.state = 1;
        }
      }



      else if (tutState(6,12)){
                tutorialRadio.radioButtons[7].flashOn();
                helpBang.hide();
                backgroundBang.hide();

        if (oneTimeEvent(6,12)){
          
        }
      }



    previousTutButtonStates[6] = tutButtonArray[6].state;
  } // end of lesson 7


//               88888888888
//            88888888888888888
//           8888           8888
//           8888           8888
//           8888           8888
//           8888           8888
//             8888      8888
//               8888888888
//             88888888888888
//           8888           8888
//           8888           8888
//           8888           8888
//           8888           8888
//            88888888888888888
//              8888888888888
//
//  index 7

    if (tutorialRadio.isItActive(7) )      { 
           tutButtonArray[7].update();

           hideColor4();

           hideSpace();
           hideTime();
           hideFrameBox();
           hideGlobalSliders();
           hideButtons2();
           hideButtons();
       
           helpBang.state=0;

           hideBinsBox();
           hideNumBox();
           setColor4(0,0,0);

      if (tutState(7,0)){
        /*
        hueSlider.flashOn();
        satSlider.flashOn();
        brightSlider.flashOn();
        hueIncSlider.flashOn();
        satIncSlider.flashOn();
        valIncSlider.flashOn();
        */
        hueTimeSlider.flashOn();
        satTimeSlider.flashOn();
        valTimeSlider.flashOn();


        if(oneTimeEvent(7,0)){
          setBinNum(7,13);
          setColor1(180,50,50);
          setColor2(0,0,0);
          setColor3(0,0,0);
          setColor4(0,0,0);
          setGlobal(1,0,1);
          updateGlobalBox();
          stickyBang.state=0;
        }
      } 

      else if (tutState(7,1)){
        hueTimeSlider.flashOn();
        satTimeSlider.hide();
        satTimeBang.hide();
        valTimeSlider.hide();
        valTimeBang.hide();

        setColor4(0,0,0);
        if(oneTimeEvent(7,1)){
          setBinNum(7,13);
          setColor1(180,50,50);
          setColor2(0,0,0);
          setColor3(25,0,0); 
          dropSines();
         //setColor4(0,0,0);
        }

      }

      else if (tutState(7,2)){
        hueTimeSlider.flashOn();
        hueIncSlider.flashOn();
        satTimeSlider.hide();
        satTimeBang.hide();
        valTimeSlider.hide();
        valTimeBang.hide();


        if (oneTimeEvent(7,2)){
          setColor2(6,0,0);
          setColor3(25,0,0);
        }
      }

      else if (tutState(7,3)){
        satTimeSlider.flashOn();
        hueTimeSlider.hide();
        hueTimeBang.hide();
        valTimeSlider.hide();
        valTimeBang.hide();

        if (oneTimeEvent(7,3)){
          setColor1(180,50,99);
          setColor2(0,0,0);
          setColor3(0,40,0);
        }
      }

      else if (tutState(7,4)){
        satIncSlider.flashOn();
        satTimeSlider.flashOn();

        hueTimeSlider.hide();
        hueTimeBang.hide();
        valTimeSlider.hide();
        valTimeBang.hide();

        if(oneTimeEvent(7,4)){
          setColor2(0,8,0);
          setColor3(0,20,0);
        }
      }

      else if(tutState(7,5)){
        valTimeSlider.flashOn();
        hueTimeSlider.hide();
        hueTimeBang.hide();
        satTimeSlider.hide();
        satTimeBang.hide();

        if(oneTimeEvent(7,5)){
          setColor2(0,0,0);
          setColor3(0,0,20);

        }
      }

      else if (tutState(7,6)){
        valTimeSlider.flashOn();
        valIncSlider.flashOn();
        hueTimeSlider.hide();
        hueTimeBang.hide();
        satTimeSlider.hide();
        satTimeBang.hide();

        if(oneTimeEvent(7,6)){
          setColor2(0,0,10);
          setColor3(0,0,20);
        }
      }


      else if(tutState(7,7)){
        valTimeSlider.flashOn();
        hueTimeSlider.flashOn();
        satTimeSlider.flashOn();
        if(oneTimeEvent(7,7)){
          setColor2(3, 5, -9);
          setColor3(-15, 63, 40);
        }
      }

      else if (tutState(7,8)){
        tutorialRadio.radioButtons[8].flashOn();
      }




    previousTutButtonStates[7] = tutButtonArray[7].state;
  } // end of lesson 8


  //
//           666666666666
//         6666666666666666
//         6666        6666
//         6666        6666
//         6666        6666
//         6666        6666
//           666666666666
//               6666666
//                 6666
//                6666
//               6666
//              6666
//             6666

    if (tutorialRadio.isItActive(8) )      { 
           tutButtonArray[8].update();

        hideGlobalSliders();
        hideBinsBox();
        hideNumBox();
       // hideSpace();
        //hideTime();
        hideButtons();
        hideFrameBox();
        hideButtons2();
        helpBang.state = 0;

        

      if (tutState(8,0)){


        if(oneTimeEvent(8,0)){
          //hideSpaceTime();
          hideSpace();
          hideTime();
          setBinNum(7,13);
          setColor1(180,50,50);
          setColor2(0,0,0);
          setColor3(0,0,0);
          setColor4(0,0,0);

          setGlobal(1,0,1);
          updateGlobalBox();

        }

      }

      else if (tutState(8,1)){
        hideSpace();
        hideTime();
        hueIncTimeSlider.flashOn();
        satIncTimeSlider.hide();
        satIncTimeBang.hide();
        valIncTimeSlider.hide();
        valIncTimeBang.hide();

        if(oneTimeEvent(8,1)){
          setColor1(180,50,80);
          setColor2(0,0,0);
          setColor3(0,0,0);
          setColor4(9,0,0);
          dropSines();
        }

      }

      else if (tutState(8,2)){
        valIncTimeSlider.hide();
        valIncTimeBang.hide();
        hueIncTimeSlider.hide();
        hueIncTimeBang.hide();
        satIncTimeSlider.flashOn();
        hideSpace();
        hideTime();
        if(oneTimeEvent(8,2)){
          setColor2(0,0,0);
          setColor3(0,0,0);
          setColor4(0,9,0);
        }
      }

      else if (tutState(8,3)){
        hueIncTimeSlider.hide();
        hueIncTimeBang.hide();
        satIncTimeSlider.hide();
        satIncTimeBang.hide();
        valIncTimeSlider.flashOn();
        hideSpace();
        hideTime();
        if(oneTimeEvent(8,3)){
          setColor2(0,0,0);
          setColor3(0,0,0);
          setColor4(0,0,9);
        }
      }

      else if (tutState(8,4)){
        hueIncTimeSlider.flashOn();
        satIncTimeSlider.flashOn();
        valIncTimeSlider.flashOn();
        hideSpace();
        hideTime();
        if(oneTimeEvent(8,4)){
          setColor4(-3, 5, 9);
        }
      }

      else if (tutState(8,5)){
        hueTimeSlider.flashOn();
        satTimeSlider.flashOn();
        valTimeSlider.flashOn();
        hideSpace();
        hideTime();
        if(oneTimeEvent(8,5)){
          setColor3(70,-65,50);
        }
      }

      else if (tutState(8,6)){
        if(oneTimeEvent(8,6)){
          for (int i = 0; i < numSine; i++){
            fv(i, i+1);
            pv(i, 0);
            av(i, 100);
            dfv(i, 2+random(-1,1));
            dpv(i, 5+0.25*random(-1,1));
            dav(i, 8+0.25+random(-1,1));
          }

        }
      }

      else if (tutState(8,7)){
        tutorialRadio.radioButtons[8].flashOn();
      }
    previousTutButtonStates[8] = tutButtonArray[8].state;
  } // end of lesson 9.

  // If none of the tutorial buttons are selected, display the tenth text-button. This is the "default"
  if(tutorialRadio.allOff() == true) {tutButtonArray[9].update(); }



//println(showTutButtons);
  if (showTutButtons){
   tutorialRadio.update();
 }



}
