

/* This SliderBar class is a pared down and modified version of the "sliderBar Class" by Alejandro Dirgan,
licensed under Creative Commons Attribution-Share Alike 3.0 and GNU GPL license.
Work: http://openprocessing.org/visuals/?visualID= 59987  
License: 
http://creativecommons.org/licenses/by-sa/3.0/
http://creativecommons.org/licenses/GPL/2.0/
*/
 
 
class SliderBar
{
  
  int[] labelArray; 
  boolean useLabelArray = false;
 
  boolean showSlider = true; // When set to false, the slider bar will not be visible and will not update.
  boolean flashing = false;

  color backgroundColor;
  color foregroundColor;
  color foregroundColor2;

  color backgroundColorDay;
  color foregroundColorDay;
  color foregroundColor2Day;
  color labelColorDay; 
  color backgroundColorNite;
  color foregroundColorNite ;
  color foregroundColor2Nite ;
  color labelColorNite;
    
  color borderColor=0;
  color numbersColor;
  color labelColor;
   
  boolean backgroundVisible=true;  // the background is the grey rectangle that is behind the "controller" rectangle
  
  int labelSize=12;
  int numberSize=14;
  boolean visibleText=true;
  boolean visibleNumbers=false;
  boolean secondaryValues = false;
  boolean rightClickReset = false;
   
  int pX, pY, pW, pH;
   
  float pScaled=0, pValue=0;  // Primary value
  float pScaled2=0, pValue2=0; // Secondary value
  float resetValue;            // Value to set slider to if it is reset (if rightClickReset = true)

  int adjustValue = 4; //Default: 4. This accounts for the width of the slider 
   
  //String ID;
   
  boolean debug=false;
  boolean pressOnlyOnce=true;
  int deb=0;
   
  float vMin=0, vMax=15;
   
  int O_HOR=1;
  int O_VER=2;
   
  int orientation=O_HOR;

  Flash horzFlash, vertFlash;
  String helpText = "";
  String helpTitleText = "";
  String labelText = "";
  float labelWidth;//
   
  SliderBar(int x, int y, int w, int h, float iValue, float fValue)
  {
     pX=x;
     pY=y;
     pW=w;
     pH=h;
     
      
     setLimits(iValue, fValue);

      backgroundColorDay = color(0,0,90);
      foregroundColorDay = color(0,0,70);
      foregroundColor2Day = color(0,0,80);
      labelColorDay = color (0, 0, 0);
      
      backgroundColorNite = color(0,00,20);
      foregroundColorNite = color (0,0,50);
      foregroundColor2Nite = color (0,0,25);
      labelColorNite = color (0, 0, 100);

      numbersColor= color (0, 100, 100);

      horzFlash = new Flash(pX, pY, pW, pH, 4, 50, 100, 100);
      vertFlash = new Flash(pX, pY, pH, pW, 4, 50, 100, 100);
         
  }
 

////////////////////////////
///////////////////////////


void setHelpText(String helpTitleText_, String helpText_){
    helpTitleText = helpTitleText_;
    helpText = helpText_;
}

void drawToolTip(){

if (backgroundBang.state==0){
    fill(0,0,80);
} else {
    fill(0,0,40);
}

textFont(helpTitleFont);
textAlign(LEFT, TOP);
text(helpTitleText, helpX + 10, helpY, helpW - 10, helpH);

float titleWidth = textWidth(helpTitleText); 

if (backgroundBang.state==0){
    fill(0,0,0);
} else {
    fill(0,0,100);
}

textFont(helpFont);
//text(helpText_, helpX, helpY, helpW, helpH);
textAlign(LEFT, TOP);
textLeading(16);
text(helpText, helpX + titleWidth + 25 ,helpY + 4,helpW - titleWidth - 25 - 10, helpH );

}



void hide(){
    showSlider = false;
}

void flashOn(){
    flashing = true;
}




void chooseColors(){
  if (backgroundBang.state == 0) {
      foregroundColor = foregroundColorDay;
      foregroundColor2 = foregroundColor2Day;
      backgroundColor = backgroundColorDay;
      labelColor = labelColorDay;

  } else {
      foregroundColor = foregroundColorNite;
      foregroundColor2 = foregroundColor2Nite;
      backgroundColor = backgroundColorNite;
      labelColor = labelColorNite;
  }


}



  ////////////////////////////////////////////////////////
  public float getValue()
  {
    return pValue;
  }

  public float getValue2()
  {
    return pValue2;
  }
   
   
  ////////////////////////////////////////////////////////

  public void setOrientation(int o)
  {
    if (o<1) o=1;
    if (o>2) o=2;
     
    orientation=o;
  }
  ////////////////////////////////////////////////////////
  public void setLimits(float iv, float fv)
  {
     vMin=iv;
     vMax=fv;    
      
     setValue(iv);
     setValue2(iv);
      
  }


  ////////////////////////////////////////////////////////
  public void showLabel()
  {
    visibleText=true;
  }
  ////////////////////////////////////////////////////////
  public void hideLabel()
  {
    visibleText=false;
  }
  ////////////////////////////////////////////////////////
  public void showNumbers()
  {
    visibleNumbers=true;
  }
  ////////////////////////////////////////////////////////
  public void hideNumbers()
  {
    visibleNumbers=false;
  }
   
  ////////////////////////////////////////////////////////
  /*
  private float round2nDecimals(float number, float decimal) {
      return (float)(round((number*pow(10, decimal))))/pow(10, decimal);
  } 
  */
  ////////////////////////////////////////////////////////



 void setTwoValuesOn() {
  secondaryValues = true;
 }
 void setTwoValuesOff() {
  secondaryValues = false;
 }
 void rightClickResetOn(){
  rightClickReset = true;
 }
 void rightClickResetOff(){
  rightClickReset = false;
 }

void rightClickResetFunction(float value_){
  pValue = value_;
}
void setResetValue(float value_){
  resetValue = value_;
}

void labelsFromArray(int[] array_){
  labelArray = array_;
  useLabelArray = true;
}

  ///////////////////////////////////////////////////////
  private boolean mouseOver()
  {
    boolean result=false;
     
     
    if (orientation==O_HOR)
    {
       if (mouseX>=pX && mouseX<=pX+pW && mouseY>=pY && mouseY<=pY+pH)
         result=true;
    }
    else 
         if (mouseX >= pX && mouseX<=pX+pH && mouseY>= pY  &&  mouseY <= pY+pW ) 
         result=true;
     
    return result;
  }
  ///////////////////////////////////////////////////////
  

void setupTextLabels(){
  
      fill(labelColor);
      textSize(labelSize);
      textAlign(CENTER);

  if (useLabelArray == true){
    labelText = str(labelArray[int(pValue)]);
  } else {
    labelText = str((int)pValue);
  }

  labelWidth = textWidth(labelText);


}

  private void drawText()
  {
  fill(labelColor);
    if (visibleText)
    {

      if (orientation==O_HOR){
         text(labelText,pX+pW/2,pY+pH/2+labelSize/2-2);} 
   
       
      else // vert orientation 
      {  text(labelText,pX+pH/2, pY+pW/2 +labelSize/2-2);
           
      }
    }
      
  }

/*

  private void drawText()
  {
    if (visibleText)
    {
      fill(labelColor);
      textSize(labelSize);
      textAlign(CENTER);
      if (orientation==O_HOR){
        if (useLabelArray == true){

          text(str(labelArray[int(pValue)]), pX+pW/2,pY+pH/2+labelSize/2-2);
        } else {
          text(str((int )pValue),pX+pW/2,pY+pH/2+labelSize/2-2);} 
        }
       
      else // vert orientation 
      {
        if (useLabelArray == true){
              text(str(labelArray[int(pValue)]), pX+pH/2, pY+pW/2 +labelSize/2-2);
          } else {
              text(str((int)pValue),pX+pH/2, pY+pW/2 +labelSize/2-2);
          }
   
        

      }
    }
      
  } */
  ///////////////////////////////////////////////////////
  private void drawVerticalBar()
  {
    if (backgroundVisible)
    {
      fill(backgroundColor);
      noStroke();
      //rect(pX + 3*pH/8 ,pY,pH/4,pW);
      rect(pX, pY, pH, pW);
    }
  
   
 
   
   if(secondaryValues) {
    fill(foregroundColor2);
    noStroke();
    rect(pX, pY+pScaled2, pH, 5);
    
   }


      
 


      if (flashing){
        vertFlash.display();
      }
   

      fill(foregroundColor);
      noStroke();
   // This is the "indicator" on the slider
     //textSize(labelSize);

     rect(pX, pY + pScaled, pH, 5);

    
 


    
 
     
 
  }
  ///////////////////////////////////////////////////////
  private void drawHorizontalBar()
  {
    
    if (backgroundVisible)
    {
     fill(backgroundColor);
     noStroke();
      rect(pX, pY, pW, pH); 
    }
   

    if(secondaryValues) {
    fill(foregroundColor2);
    noStroke();
    rect(pX+pScaled2, pY, 5, pH);
    
   }

      if (flashing){
        horzFlash.display();
      }
   

    fill(foregroundColor);
    noStroke();
    rect(pX+pScaled, pY, 5, pH);
  // rect(pX+pScaled, pY, labelWidth, pH);
    
       
       
    
  }
  ///////////////////////////////////////////////////////
  private void drawBar()
  {
     
    if (orientation==O_HOR) drawHorizontalBar();
    if (orientation==O_VER) drawVerticalBar();
     
     
  }
   
  ///////////////////////////////////////////////////////
  public  void setValue(float value)
   {



      if (value>vMax) value=vMax;
      if (value<vMin) value=vMin;
      pValue=value;
      if (orientation==O_HOR)
        pScaled=map(pValue,vMin,vMax,0,pW-adjustValue);
      else
        pScaled=map(pValue,vMin,vMax,pW-adjustValue,0);
   }


   public  void setValue2(float value)
 {
    if (value>vMax) value=vMax;
    if (value<vMin) value=vMin;
    pValue2=value;
    if (orientation==O_HOR)
      pScaled2=map(pValue2,vMin,vMax,0,pW-adjustValue);
    else
      pScaled2=map(pValue2,vMin,vMax,pW-adjustValue,0);
 }
    
  ///////////////////////////////////////////////////////
  private void checkMouse()
  {
    if (debug)
    {
      if (mouseOver()  && keyPressed && mouseButton==LEFT && mousePressed)
      {
        if (keyCode==CONTROL)
        {
          pX=pX+mouseX-pmouseX;
          pY=pY+mouseY-pmouseY;
        }
        if (keyCode==SHIFT && pressOnlyOnce)
        {
          pressOnlyOnce=false;
        }
        deBounce(3);
      }
       
    }
  } 
  ///////////////////////////////////////////////////////
  private void checkKeyboard()
  {
     if (mouseOver())
     {
       
       if (mousePressed && mouseButton==LEFT)
       {
         if (orientation==O_HOR)
           pValue=(float)map((mouseX-pX),0,pW-adjustValue,vMin,vMax);
         else
           pValue=(float)map((mouseY-pY),pW-adjustValue,0,vMin,vMax);
             
         if (pValue>vMax) pValue=vMax;
         if (pValue<vMin) pValue=vMin;
       }


       if (mousePressed && mouseButton==RIGHT && rightClickReset==false){

     
       
         if (orientation==O_HOR)
           pValue2=(float)map((mouseX-pX),0,pW-adjustValue,vMin,vMax);
         else
           pValue2=(float)map((mouseY-pY),pW-adjustValue,0,vMin,vMax);
             
         if (pValue2>vMax) pValue2=vMax;
         if (pValue2<vMin) pValue2=vMin;
       }
       
       
      if (mousePressed && mouseButton==RIGHT && rightClickReset==true){
       rightClickResetFunction(resetValue);
      }
 
 
       if (keyPressed && pressOnlyOnce)
       {
         if (keyCode==LEFT || keyCode==DOWN) pValue--;
         if (keyCode==RIGHT || keyCode==UP) pValue++;
         if (pValue>vMax) pValue=vMax;
         if (pValue<vMin) pValue=vMin;
         pressOnlyOnce=false;
       }
       deBounce(5);
 

       if (orientation==O_HOR){
         pScaled=map(pValue,vMin,vMax,0,pW-adjustValue);
         pScaled2=map(pValue2, vMin, vMax,0, pW-adjustValue);
       }
       else {
         pScaled=map(pValue,vMin,vMax,pW-adjustValue,0);
         pScaled2=map(pValue2, vMin, vMax, pW-adjustValue, 0);
       }
        


        
     }
   } 
  ///////////////////////////////////////////////////////
  private void change()
  {
    checkKeyboard();
    checkMouse();
  }
  ///////////////////////////////////////////////////////
  public float update() {

        chooseColors();
     if (showSlider){
        setupTextLabels();
        drawBar();
        drawText();

        if(mouseOver() &&  helpBang.state==1){
         drawToolTip();
        }
      }
        change();

    

    showSlider = true;   
    flashing = false;
    return pValue; 

  }
  ///////////////////////////////////////////////////////
 

 
/////////////////////////////////////////////////////// 
  private void deBounce(int n)
  {
    if (pressOnlyOnce)
      return;
    else
       
    if (deb++ > n)
    {
      deb=0;
      pressOnlyOnce=true;
    }
     
  }   
  /////////////////////////////////////////////////////// 



   
}


// Sometimes I wonder if there's anything more to life than just sine waves... 
