// This function calculates the average values of a slider array, and then averages each value with the overall average.


class SliderControl {

BangButton  minus, explode, collapse,  plus;
BangButton labelButton;

boolean showButtons = true;

int x, y, h;
int w1, w2, w3, w4;
int yButton;

SliderBar[] sliders;
int numSliderBar;
float setValue;
float[] newValues;
float minimum, maximum;
String label;
int hSpace, wSpace;
int numValues;
float resetValue;

float sliderLength;
float sliderWidth;
int sliderWidth30, sliderWidth40, sliderWidthNorm, sliderWidth40odd;

color labelTextColor, labelBackgroundColor, buttonTextColor, minusColor, explodeColor, collapseColor, plusColor;

    int numStates = 1;



int prevMinus, prevPlus, prevExplode, prevCollapse;


   SliderControl (int x_, int y_, float min_, float max_, int numSliderBar_, float setValue_, String label_, int numValues_, float resetValue_){

     x = x_;
     y = y_;
     minimum = min_;
     maximum = max_;

     numValues=numValues_;

     numSliderBar = numSliderBar_;
     setValue = setValue_;

     label = label_;
     resetValue = resetValue_;
      
    sliders = new SliderBar[numSliderBar];
    newValues = new float[numSliderBar];
     
     w1 = 18;
     w2 = 19;
     w3 = 19;
     w4 = 18;

     h = 18;

     sliderLength = 74;

     sliderWidthNorm = 20;
     sliderWidth30 = 17;
     sliderWidth40 = 12;
     sliderWidth40odd = 13;


    int prevMinus, prevPlus, prevExplode, prevCollapse;



    wSpace = 0;
    hSpace = 10;
    
    
     for (int i = 0;  i < numSliderBar; i++){
      if(numSliderBar==40){
        sliderWidth = sliderWidth40;
      } else if (numSliderBar==30) {
        sliderWidth = sliderWidth30;
      } else {
        sliderWidth = sliderWidthNorm;
      }


           sliders[i] = new SliderBar(x, int(floor(baselines[i]) - floor(boxHeight/2) - sliderWidth/2) + sinesTranslateY, int(sliderLength), int(sliderWidth), minimum, maximum);
           if(numSliderBar==40 && i%2==0){//make the even indexed slider bars 1 pixel wider to have even gaps between sliders. (for aesthetics).
            sliders[i] = new SliderBar(x, int(floor(baselines[i]) - floor(boxHeight/2) - sliderWidth/2) + sinesTranslateY, int(sliderLength), int(sliderWidth40odd), minimum, maximum);

           }

           sliders[i].setOrientation(1);
           sliders[i].setValue(setValue);
           //sliders[i].setHelpText(label,"This slider controls the " + label + " of sine number " + (i+1)+". It ranges from " + minimum +" to " + maximum +". \nRight-click to reset value to " + resetValue+"." );
           if (numValues==2){
            sliders[i].setTwoValuesOn();
           } else if (numValues == 1) {
            sliders[i].rightClickResetOn();
            sliders[i].setResetValue(resetValue);
           } else {
            sliders[i].rightClickResetOn();
            sliders[i].setResetValue(i+1);

           }
        }
   
    yButton = int(baselines[numSliderBar-1] - boxHeight/2 - sliderWidth/2) + sinesTranslateY - hSpace - h;
    
    minus = new BangButton(x, yButton , w1, h, "", numStates);
    explode =  new BangButton(x + w1 + wSpace, yButton, w2, h, "", numStates);
    collapse = new  BangButton(x + w1 + w2 + 2*wSpace, yButton, w3, h, "", numStates);
    plus =  new BangButton(x + w1+w2+w3 + 3*wSpace, yButton, w4, h, "", numStates);

    labelButton = new BangButton(int(x), yButton - 20, w1+w2+w3+w4, 20, "",numStates);


     updateColors();
     
     minus.setHelpText("-", "Minus decreases the value of all sliders in this column by an equal amount.");
     explode.setHelpText(")(", "Expand randomly steps each slider in this column up or down.\nThis is useful for making sines slightly out of sync with each other.");
     collapse.setHelpText("()", "Collapse calculates the average of all the sliders in this column, then moves each slider half the distance to the average. This is useful for bring sines in sync.");
     plus.setHelpText("+", "Plus increases the value of all sliders in this column by an equal amount.");

   }//end constructor




//////++++++++++++++++++++++++++++++++++++++++++++++++++++++++ begin function
  // FUNCTION 
   void update(){

    updateColors();

  //textAlign(CENTER);
 // fill(0,0,0);
  //text(label, x+sliderLength/2, yButton - 5);


     for (int i  = 0; i < numSliderBar; i ++){
       sliders[i].update();
 }

 
  if (showButtons){
     minus.update();
    explode.update();
    collapse.update();
    plus.update();
  }

  labelButton.update();
    





   


 if (collapse.toggleCount != prevCollapse) { 
    updatePrevious(); 

    newValues = collapseEval(sliderValuesArray());

    for (int i = 0; i < sliders.length; i++){
      sliders[i].setValue(newValues[i]);
    }  
     

 }



 else if (plus.toggleCount != prevPlus)   {
 updatePrevious();  
 newValues = plusEval(sliderValuesArray());

 for (int i = 0; i<sliders.length; i++){
   sliders[i].setValue(newValues[i]);
 }
}
 



 else if ( explode.toggleCount != prevExplode)  { 
     updatePrevious();

     newValues = explodeEval(sliderValuesArray());

     for (int i = 0; i < sliders.length; i++){
       sliders[i].setValue(newValues[i]);
     }
 }



 else if (minus.toggleCount != prevMinus) {
  updatePrevious();
  newValues = minusEval(sliderValuesArray());

  for (int i = 0; i < sliders.length; i++){
    sliders[i].setValue(newValues[i]);

  }
}
 
 else {updatePrevious();   sliderValuesArray();}


 //showButtons = true;

 }/////-------------------------------------------------------- end update



 void updateColors(){

      // lights on color
     if (backgroundBang.state==0) {
      labelTextColor = color(0,0,0);
      labelBackgroundColor = color(0,0,100, 0);

      buttonTextColor = color(0,0,0);

      minusColor = color (150, 10, 100);
      explodeColor = color(200, 10, 100);
      collapseColor = color(240, 10, 100);
      plusColor = color(270, 10, 100);

     } else {

      // lights off color
      labelTextColor = color(0,0,100);
      labelBackgroundColor = color(0,50,1,0);

      buttonTextColor = color(0,0,100);

      minusColor = color (150, 50, 40);
      explodeColor = color(200, 50, 40);
      collapseColor = color(240, 50, 40);
      plusColor = color(270, 50, 40);
     }

    minus.setState(0, 0, "-", minusColor, buttonTextColor);
    explode.setState(0, 0, ")(", explodeColor, buttonTextColor);
    collapse.setState(0, 0, "()", collapseColor, buttonTextColor);
    plus.setState(0, 0, "+", plusColor, buttonTextColor);
    labelButton.setState(0,0, label, labelBackgroundColor, labelTextColor);

 }



  void updatePrevious(){
    prevMinus = minus.toggleCount;
    prevPlus = plus.toggleCount;
    prevCollapse = collapse.toggleCount;
    prevExplode = explode.toggleCount;
  }


 // This function returns the values of each slider
   float sliderValues(int index) {
      
    float[] values = new float[sliders.length];

     for (int i = 0; i < sliders.length; i++) {
       values[i] = sliders[i].getValue();
     }

    return values[index];
   }

   float returnNewValues(int index){
    sliders[index].setValue(newValues[index]);
    return newValues[index];

   }

float[] sliderValuesArray() {
  float[] values = new float[sliders.length];

  for (int i = 0; i < sliders.length; i++){
    values[i] = sliders[i].getValue();
  }

  return values;
}




float[] collapseEval (float[] inputs_) {
        float[] inputs = new float[inputs_.length];
        float[] outputs = new float[inputs_.length];

        inputs = inputs_;
        float sum = 0;
        float mean = 0;

        for (int i = 0; i < inputs.length; i++){
            sum += inputs[i];
        }
          
        mean = sum / inputs.length;

        for (int i =0; i < inputs.length; i++){

           outputs[i] = (inputs[i] + mean)/2;
        }

        return outputs;

 } // end average function\


float[] explodeEval (float[] inputs_) {
  float[] inputs = new float[inputs_.length];
  float[] outputs = new float[inputs_.length];

  inputs = inputs_;
  float sum = 0;
  float mean = 0;

  for (int i = 0; i < inputs.length; i++){
         sum += inputs[i];
  }

  mean = sum / inputs.length;


  for (int i = 0; i < inputs.length; i++){
   outputs[i] = inputs[i] + random(-1,1) * .05 * (maximum - minimum);
  }

  return outputs;
}


float[] plusEval(float[] inputs_) {
  float[] inputs = new float[inputs_.length];
  float[] outputs = new float[inputs_.length];
  inputs = inputs_;

   for (int i = 0; i < inputs.length; i++){
    outputs[i]  = inputs[i] + .04 * (maximum - minimum);
   }
return outputs;
}


float[] minusEval(float[] inputs_) {
    float[] inputs = new float[inputs_.length];
    float[] outputs = new float[inputs_.length];
    inputs = inputs_;

   for (int i = 0; i < inputs.length; i++){
    outputs[i]  = inputs[i] - .04 * (maximum - minimum);
   }

   return outputs;
}


void buttonsOff() {
  showButtons = false;
}

void buttonsOn(){
  showButtons = true;
}


void flipValues(){
    float[] tempValues = new float[numSine];
    for (int j = 0; j < numSine; j++){
      tempValues[j] = sliders[j].getValue();
    }
    for (int j = 0; j < numSine; j++){
      sliders[j].setValue(tempValues[numSine-1-j]);
    }
  }

void setAllToZero(){
  for (int j = 0; j < numSine; j++){
    sliders[j].setValue(0);
  }
}


} // end SliderControl class
